org.apache.commons.ssl

## Class Base64InputStream

- java.lang.Object
- - java.io.InputStream
  - - java.io.FilterInputStream
    - - org.apache.commons.ssl.Base64InputStream

All Implemented Interfaces:
  java.io.Closeable, java.lang.AutoCloseable

    public class Base64InputStream
    extends java.io.FilterInputStream

Provides Base64 encoding and decoding in a streaming fashion (unlimited size). When encoding the default lineLength is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate constructor.

The default behaviour of the Base64InputStream is to DECODE, whereas the default behaviour of the Base64OutputStream is to ENCODE, but this behaviour can be overridden by using a different constructor.

This class implements section 6.8. Base64 Content-Transfer-Encoding from RFC 2045 Multipurpose Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies by Freed and Borenstein.

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

Since:
  1.4
Version:
  $Id: Base64InputStream.java 155 2009-09-17 21:00:58Z julius $
Author:
  Apache Software Foundation
See Also:
  RFC 2045

### Field Summary

Fields
`private Base64` `base64`
`private boolean` `doEncode`
`private byte[]` `singleByte`

### Fields inherited from class java.io.FilterInputStream

`in`

### Constructor Summary

Constructors
Constructor and Description
`Base64InputStream(java.io.InputStream in)` Creates a Base64InputStream such that all data read is Base64-decoded from the original provided InputStream.
`Base64InputStream(java.io.InputStream in, boolean doEncode)` Creates a Base64InputStream such that all data read is either Base64-encoded or Base64-decoded from the original provided InputStream.
`Base64InputStream(java.io.InputStream in, boolean doEncode, int lineLength, byte[] lineSeparator)` Creates a Base64InputStream such that all data read is either Base64-encoded or Base64-decoded from the original provided InputStream.

### Method Summary

Methods
`boolean` `markSupported()`
`int` `read()` Reads one `byte` from this input stream.
`int` `read(byte[] b, int offset, int len)` Attempts to read `len` bytes into the specified `b` array starting at `offset` from this InputStream.

### Methods inherited from class java.io.FilterInputStream

`available, close, mark, read, reset, skip`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### doEncode

    private final boolean doEncode

#### base64

    private final Base64 base64

#### singleByte

    private final byte[] singleByte

### Constructor Detail

#### Base64InputStream

    public Base64InputStream(java.io.InputStream in)

Creates a Base64InputStream such that all data read is Base64-decoded from the original provided InputStream.

Parameters:
  `in` - InputStream to wrap.

#### Base64InputStream

    public Base64InputStream(java.io.InputStream in,
                     boolean doEncode)

Creates a Base64InputStream such that all data read is either Base64-encoded or Base64-decoded from the original provided InputStream.

Parameters:
  `in` - InputStream to wrap.
  `doEncode` - true if we should encode all data read from us, false if we should decode.

#### Base64InputStream

    public Base64InputStream(java.io.InputStream in,
                     boolean doEncode,
                     int lineLength,
                     byte[] lineSeparator)

Creates a Base64InputStream such that all data read is either Base64-encoded or Base64-decoded from the original provided InputStream.

Parameters:
  `in` - InputStream to wrap.
  `doEncode` - true if we should encode all data read from us, false if we should decode.
  `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to nearest multiple of 4). If lineLength <=0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
  `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.

### Method Detail

#### read

    public int read()
             throws java.io.IOException

Reads one `byte` from this input stream.

Overrides:
  `read` in class `java.io.FilterInputStream`
Returns:
  the byte as an integer in the range 0 to 255. Returns -1 if EOF has been reached.
Throws:
  `java.io.IOException` - if an I/O error occurs.

#### read

    public int read(byte[] b,
           int offset,
           int len)
             throws java.io.IOException

Attempts to read `len` bytes into the specified `b` array starting at `offset` from this InputStream.

Overrides:
  `read` in class `java.io.FilterInputStream`
Parameters:
  `b` - destination byte array
  `offset` - where to start writing the bytes
  `len` - maximum number of bytes to read
Returns:
  number of bytes read
Throws:
  `java.io.IOException` - if an I/O error occurs.
  `java.lang.NullPointerException` - if the byte array parameter is null
  `java.lang.IndexOutOfBoundsException` - if offset, len or buffer size are invalid

#### markSupported

    public boolean markSupported()

Overrides:
  `markSupported` in class `java.io.FilterInputStream`
Returns:
  false